#define F_CPU 16000000UL
#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>
#define DELAY 600
#define DELAY_SHORT 100

    uint8_t board[8][8]={0};
    int FromX,FromY,ToX,ToY;
    int IX=9,IY=9; // 9 is initial state
    uint16_t blinkcount = 0b00000000;
	uint8_t blinker = 1;
	uint8_t wincolor = 0;

int IO(){
    int rb,gb;
    int i,j;
    for(i=0;i<8;i++){
                     for(j=0;j<4;j++){
                            rb=gb=0;
                        switch(board[i][(int)(j<<1)+(int)(i&0b00000001)]){
                            case 1:rb=1;break;
                            case 3:gb=1;break;
                            case 5:rb=blinker;break; // Blink
                            case 7:gb=blinker;break; // Blink
                        }
                        PORTC= j + (i<<2);
                        PORTB=0b00111100| rb | gb<<1 ;
                        _delay_us(DELAY_SHORT);
                        blinker = ((blinkcount>>10) %2 > 0)? 1: 0;
						blinkcount++;
                     }
                     inputrow(i);
    }
    return 0;
}
int inputrow(int i){
    int inp[4];
    int k;
    int iix,iiy;
    inp[0]= ((PINB & 0b00000100)==0)? 1:0;
    inp[1]= ((PINB & 0b00001000)==0)? 1:0;
    inp[2]= ((PINB & 0b00010000)==0)? 1:0;
    inp[3]= ((PINB & 0b00100000)==0)? 1:0;
    for(k=0;k<4;k++){
        if(inp[k]){
		iix= ((k<<1) + (int)(i&1));
                iiy=i;
                if((IX==9)&&(IY==9)){
                    IX= iix;
                    IY= iiy;
                    return 0;
                }else{
                    if((IX!=iix)&&(IY!=iiy)){
                        FromX=IX; FromY=IY;
                        ToX=iix; ToY=iiy;
                        IX=IY=9;
                        return 0;
                    }else{
                        // double key hit (or hold): do nothing
                    }
                }
        }
    }
    return 0;
}


int chknevallongpath(int fX,int fY,int toX,int toY){
        int i;
        int dirX= (toX-fX>0)? 1:-1;
        int dirY= (toY-fY>0)? 1:-1;
        int me=board[fY][fX];
        int length= (dirX==1)? toX-fX: fX-toX ;
        int lengthY= (dirY==1)? toY-fY: fY-toY ;
        if(length != lengthY){
                return 0; //imbalance x and y return invalid move
            }
        for(i=1;i<length-1;i++){
                if(board[fY+dirY*i][fX+dirX*i]!=0){
                    return 0; //unclean path
                    }
            }
        switch(board[toY-dirY][toX-dirX]){
            case 0: return 5; //normal long mov
            case 1:
            case 5: 
            case 3:
            case 7: return dirY*2+dirX;
            default: return 0;
        }        
}

int posChain(int mode){
    int chY=ToY+1,chX=ToX+1;
    if(mode&1){
        while(chY<7&&chX<7){
                if((board[chY][chX]&1>0) && ((int)(board[chY][chX]&2) != (int)(board[ToY][ToX]&2))){
                        if(board[chY+1][chX+1]==0){
                                return 1+(chY-ToY-1 + chX-ToX-1)*5;
                        }else{
                                break;
                        }
                }
                chY++;chX++;
        }
        chY=ToY+1; chX=ToX-1;
        while(chY<7&&chX>0){
                if((board[chY][chX]&1) && ((int)(board[chY][chX]&2) != (int)(board[ToY][ToX]&2))){
                        if(board[chY+1][chX-1]==0){
                                return 1+(chY-ToY-1 + chX-ToX+1)*5;
                        }else{
                                break;
                        }
                }
                chY++;chX--;
        }
    }
    if(mode&2){
        //printf("\n%d %d\n",mode,mode&1);
        chY=ToY-1; chX=ToX+1;
        while(chY>0&&chX<7){
            if((board[chY][chX]&1) && ((int) (board[chY][chX]&2) != (int)(board[ToY][ToX]&2))){
                    if(board[chY-1][chX+1]==0){
                            return 3+(chY-ToY+1 + chX-ToX-1)*5;
                        }else{
                            break;
                        }
                }
            chY--;chX++;
        }
        chY=ToY-1; chX=ToX-1;
        while(chY>0&&chX>0){
            if((board[chY][chX]&1) && ((int)(board[chY][chX]&2)!= (int)(board[ToY][ToX]&2) ) ){
                    if(board[chY-1][chX-1]==0){
                            return 3+(chY-ToY+1 + chX-ToX+1)*5;
                        }else{
                            break;
                        }
                }
            chY--;chX--;
        }
    }
    return 0;
    }
int main(){
    DDRC=0b00011111;
    DDRB=0b00000011;
    int i,j,turn=0; // 0=p1's turn 1=p2's turn
    int p1=8,p0=8,endturn=0;
    // initialize values
        board[7][1]=board[7][3]=board[7][5]=board[7][7]=3;
    board[6][0]=board[6][2]=board[6][4]=board[6][6]=3;
    //.......
        board[1][1]=board[1][3]=board[1][5]=board[1][7]=1;
    board[0][0]=board[0][2]=board[0][4]=board[0][6]=1;
    // end init
    
    while((p1>0)&&(p0>0)){
        if(turn==0){
            //------ check moveable for endgame?
            // ....
            // inputs
            do{
            endturn=0;
                    IO(); ///////////////////
                    //// pawn
                    if((board[FromY][FromX]==1)&&(board[ToY][ToX]==0)){
                            //case normal walk
                            if((ToY-FromY==1)&&((ToX-FromX==1)||(FromX-ToX==1)) ){
                                board[FromY][FromX]=0;
                                board[ToY][ToX]=1;
                                endturn=1;
                            //case eat to left
                            }else if((ToY-FromY==2)&&(FromX-ToX==2)&&(board[ToY-1][ToX+1]&1)&&(board[ToY-1][ToX+1]&2)){
                                board[FromY][FromX]=0;
                                board[ToY][ToX]=1;
                                board[FromY+1][FromX-1]=0;
								p1 -= 1;
                                //printf("\n%d\n",posChain(1));
                                endturn= (posChain(1)==1)? 0: 1;
                                if(endturn==0){
                                    IX=ToX; IY=ToY;
                                    }
                            // case eat to right
                            }else if((ToY-FromY==2)&&(ToX-FromX==2)&&(board[ToY-1][ToX-1]&1)&&(board[ToY-1][ToX-1]&2)){
                                board[FromY][FromX]=0;
                                board[ToY][ToX]=1;
                                board[FromY+1][FromX+1]=0;
								p1 -= 1;
                                //printf("\n%d\n",posChain(1));
                                endturn= (posChain(1)==1)? 0: 1;
                                if(endturn==0){
                                    IX=ToX; IY=ToY;
                                    }
                            }else{
                                //invalid move
                               // break;
                            }
                            _delay_us(DELAY);
                    }
                    //// horse
                    if((board[FromY][FromX]==5)&&(board[ToY][ToX]==0)){
						i=0;
                        switch( chknevallongpath(FromX,FromY,ToX,ToY) ){
                            case 5:endturn=1;break;
                            case 3:board[ToY-1][ToX-1]=0;endturn=1;i++;break;
                            case 1:board[ToY-1][ToX+1]=0;endturn=1;i++;break;
                            case -1:board[ToY+1][ToX-1]=0;endturn=1;i++;break;
                            case -3:board[ToY+1][ToX+1]=0;endturn=1;i++;break;
                            // default:;
                            }
                        if(endturn){
                            board[ToY][ToX]=5;
                            board[FromY][FromX]=0;
							if (i!=0)
                            	endturn= !posChain(3);
                           	if(endturn==0){
                                    IX=ToX; IY=ToY;
                            }
                        }
                            _delay_us(DELAY);
                    }
                    //// end horse
					}while(endturn==0);
                        if(ToY==7){
                            board[ToY][ToX]|=4; // in horse
                        }
                    turn=1;
        }else{
            do{
            endturn=0;
            IO(); ///////////////////
             /// pawn
                    if((board[FromY][FromX]==3)&&board[ToY][ToX]==0){
                            //case normal walk
                            if((FromY-ToY==1)&&((ToX-FromX==1)||(FromX-ToX==1)) ){
                                board[FromY][FromX]=0;
                                board[ToY][ToX]=3;
                                endturn=1;
                            //case eat to left
                            }else if((FromY-ToY==2)&&(FromX-ToX==2)&&(board[ToY+1][ToX+1]&1)&&!(board[ToY+1][ToX+1]&2)){
                                board[FromY][FromX]=0;
                                board[ToY][ToX]=3;
                                board[FromY-1][FromX-1]=0;
								p0 -= 1;
                                endturn= (posChain(2)==3)? 0: 1;
                                if(endturn==0){
                                    IX=ToX; IY=ToY;
                                    }
                            // case eat to right
                            }else if((FromY-ToY==2)&&(ToX-FromX==2)&&(board[ToY+1][ToX-1]&1)&&!(board[ToY+1][ToX-1]&2)){
                                board[FromY][FromX]=0;
                                board[ToY][ToX]=3;
                                board[FromY-1][FromX+1]=0;
								p0 -= 1;
                                endturn= (posChain(2)==3)? 0: 1;
                                if(endturn==0){
                                    IX=ToX; IY=ToY;
                                    }
                            }else{
                                //invalid move
                               // break;
                            }
                            _delay_us(DELAY);
                    }
                    //// horse
                    if((board[FromY][FromX]==7)&&(board[ToY][ToX]==0)){
						i=0;
                        switch( chknevallongpath(FromX,FromY,ToX,ToY) ){
                            case 5:endturn=1;break;
                            case 3:board[ToY-1][ToX-1]=0;endturn=1;i++;break;
                            case 1:board[ToY-1][ToX+1]=0;endturn=1;i++;break;
                            case -1:board[ToY+1][ToX-1]=0;endturn=1;i++;break;
                            case -3:board[ToY+1][ToX+1]=0;endturn=1;i++;break;
                            // default:;
                            }
                        if(endturn){
                            board[ToY][ToX]=7;
                            board[FromY][FromX]=0;
			if (i!=0)
                            	endturn= !posChain(3);
                            if(endturn==0){
                                    IX=ToX; IY=ToY;
                            }
                        }
                        _delay_us(DELAY);
                    }
                    //// end horse
                    }while(endturn==0);
                    if(ToY==0){
                            board[ToY][ToX]|=4; // in horse
                        }
                    turn=0;
        }
		ToX = FromX = 0;
		ToY = FromY = 1;
}
	//probably doesn't work.
	if (p0==0)
		wincolor = 3;
	else if (p1==0)
		wincolor = 1;
   	for (i=0;i<8;i++)
	{
		for (j=0;j<8;j++)
		{
			board[i][j] = wincolor;
		}
	}
	while(1)
	{
		IO();
	}
return 0;
}
